# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

export SRCPKG = zfs
export DEPENDS = glibc,libzfs,util-linux,spl,zlib
export ARCH = x86_64
export URL = http://zfsonlinux.org/
REPO = main
BRIEF = Module and utilities for the ZFS file system
DESC = ZFS is an advanced file system and volume manager which was originally \
developed for Solaris and is now maintained by the Illumos community.
SNAPVER = 7

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
UPVER := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'|sed 's/^-//')
export VERSION := $(UPVER)-$(SNAPVER)
SPLPATH := /usr/src/spl-$(UPVER)

LIB := $(PWD)/libzfs
LIBROOT := $(LIB)/ROOT
DEV := $(PWD)/zfs-dev
DEVROOT := $(DEV)/ROOT

include /usr/share/snap/Makefile.snaplinux

$(SRCDIR)/configure: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/configure

$(SRCDIR)/config.log: $(SRCDIR)/configure
	@cd $(SRCDIR) && \
	for patch in `find $(PATCHDIR) -name \*.patch|sort`; do \
		patch --verbose -Np1 -i $$patch; \
	done
	@cd $(SRCDIR); \
	./configure \
		--prefix=/usr \
		--with-spl=$(SPLPATH) \
		--bindir=/bin \
		--sbindir=/sbin \
		--libdir=/lib \
		--program-prefix='' \
		--disable-systemd \
		--build=x86_64-snap-linux-gnu \
		--host=x86_64-snap-linux-gnu \
		--target=x86_64-snap-linux-gnu

$(SRCDIR)/module/zfs/zfs.ko: $(SRCDIR)/config.log
	@cd $(SRCDIR) && make

$(ROOT): $(SRCDIR)/module/zfs/zfs.ko
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR) && make install DESTDIR=$(ROOT) && \
	mv $(ROOT)/etc/default/zfs $(ROOT)/usr/share/zfs/zfs.default && \
	rmdir $(ROOT)/etc/default && \
	install -v -d -m 755 $(ROOT)/etc/zfs && \
	install -v -d -m 755 $(ROOT)/lib/modules/$(PACKAGE) && \
	mv -v $(ROOT)/lib/modules/*/* $(ROOT)/lib/modules/$(PACKAGE) && \
	rm -vrf $(ROOT)/usr/share/initramfs-tools

	@install -v -d $(LIB)/SNAP && \
	install -v -d $(LIBROOT) && \
	install -v -d -m 755 $(LIBROOT)/lib && \
	install -v -d $(DEV)/SNAP && \
	install -v -d $(DEVROOT) && \
	mv -v $(ROOT)/lib/lib{nvpair,uutil,zfs,zfs_core,zpool}.{la,so}* \
		$(LIBROOT)/lib && \
	for file in `find $(ROOT)|egrep 'man3\/|\.a$$|\.c$$|\.h$$'`; do \
                path=`dirname $$file|sed "s[$(ROOT)[$(DEVROOT)["`; \
                mkdir -p $$path; \
                mv $$file $$path; \
        done && \
	find $(ROOT) -type d -empty -delete && \
	cd $(LIB) && make -f ../Makefile.libzfs && mv *.snap ../ && \
	cd $(DEV) && make -f ../Makefile.zfs-dev && mv *.snap ../

test: $(ROOT)
	@cd $(SRCDIR); \
	make check

clean:
	@rm -rvf $(ROOT) \
		$(LIB) \
		$(DEV) \
		$(SNAPINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

